Index: trunk/LMDZ.COMMON/libf/evolution/pem.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/pem.F90	(revision 2792)
+++ trunk/LMDZ.COMMON/libf/evolution/pem.F90	(revision 2794)
@@ -4,13 +4,18 @@
 ! I   Initialisation
 !    I_a READ run.def , run_pem.def
-!    I_b READ starfi_0.nc and start_0.nc
+!    I_b READ starfi_0.nc
+!    I_c READ GCM data and convert to the physical grid 
+!    I_d Compute tendencies & Save initial situation
 
 ! II  Run
-!    II_a Compute tendencies
-!    II_b Save initial situation
-!    II_c Time loop
+!    II_a update pressure, ice and tracers 
+!    II_b CO2 glaciers flows 
+!    II_c Update surface and soil temperatures
+!    II_d Update the tendencies and stopping criterion
 
 ! III Output
-!    III_a Write startfi.nc
+!    III_a Recomp tendencies for the start and startfi
+!    III_b Write start and starfi.nc
+!    III_c Write start_pem
 
 !------------------------
@@ -21,18 +26,21 @@
 !module needed for INITIALISATION
       use phyetat0_mod, only: phyetat0
-      use comsoil_h, only: tsoil, nsoilmx, ini_comsoil_h,inertiedat, mlayer
+      use comsoil_h, only: tsoil, nsoilmx, ini_comsoil_h,inertiedat, mlayer,volcapa
       use surfdat_h, only: tsurf, co2ice, emis,&
       &                    qsurf,watercap, ini_surfdat_h, &
                            albedodat, zmea, zstd, zsig, zgam, zthe, &
-      &                    hmons, summit, base
+                           hmons, summit, base,albedo_h2o_frost, &
+                          frost_albedo_threshold,emissiv
       use dimradmars_mod, only: totcloudfrac, albedo, & 
                                 ini_dimradmars_mod
       use turb_mod, only: q2, wstar, ini_turb_mod
       use dust_param_mod, only: tauscaling, ini_dust_param_mod
+!      use co2cloud_mod, only: mem_Mccn_co2, mem_Mh2o_co2,&
+!      &                        mem_Nccn_co2,ini_co2cloud
       use netcdf, only: nf90_open,NF90_NOWRITE,nf90_noerr,nf90_strerror, &
                         nf90_get_var, nf90_inq_varid, nf90_inq_dimid, &
                         nf90_inquire_dimension,nf90_close
       use phyredem, only: physdem0, physdem1
-      use tracer_mod, only: noms,nqmx ! tracer names
+      use tracer_mod, only: noms,nqmx,igcm_h2o_ice ! tracer names
 
 ! For phyredem :
@@ -49,7 +57,8 @@
       USE infotrac
       USE temps_mod_evol, ONLY: nyear, dt_pem
-      USE vertical_layers_mod, ONLY: ap,bp
-
-      use comslope_mod, ONLY: nslope,def_slope,def_slope_mean, &
+!     USE vertical_layers_mod, ONLY: ap,bp
+      USE comcstfi_h, only: pi 
+
+      USE comslope_mod, ONLY: nslope,def_slope,def_slope_mean, &
                            subslope_dist,co2ice_slope, &
                            tsurf_slope,tsoil_slope,fluxgrd_slope,&
@@ -59,26 +68,41 @@
                            iflat
 
-
+      USE geometry_mod, only: longitude_deg,latitude_deg 
+
+      use pemredem, only:  pemdem1
+      USE soil_evolution_mod, ONLY: soil_pem_CN
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! SOIL
+
+      use comsoil_h_PEM, only: ini_comsoil_h_PEM,end_comsoil_h_PEM,nsoilmx_PEM, &
+                              TI_PEM,inertiedat_PEM,alph_PEM, beta_PEM, &        ! soil thermal inertia          
+                              tsoil_PEM ,       &        !number of subsurface layers
+                              mlayer_PEM,layer_PEM, &       ! soil mid layer depths
+                              fluxgeo, &  ! geothermal flux
+                              co2_adsorbded_phys ! mass of co2 in the regolith
+      use adsorption_mod, only : regolith_co2adsorption
   IMPLICIT NONE
 
   include "dimensions.h"
   include "paramet.h"
+
+  INTEGER ngridmx
+  PARAMETER( ngridmx = 2+(jjm-1)*iim - 1/jjm   )
+
   include "comdissnew.h"
   include "comgeom.h"
   include "iniprint.h"
-
 ! Same variable's name as in the GCM
 
-      INTEGER :: ngrid      !Number of physical grid points
-      INTEGER :: nlayer     !Number of vertical layer
-      INTEGER :: nq         !Number of tracer
-      INTEGER :: day_ini    !First day of the simulation
-      REAL :: pday          !Physical day
-      REAL :: time_phys     !Same as GCM
-      REAL :: ptimestep     !Same as GCM
-      REAL :: ztime_fin     !Same as GCM
+  INTEGER :: ngrid      !Number of physical grid points
+  INTEGER :: nlayer     !Number of vertical layer
+  INTEGER :: nq         !Number of tracer
+  INTEGER :: day_ini    !First day of the simulation
+  REAL :: pday          !Physical day
+  REAL :: time_phys     !Same as GCM
+  REAL :: ptimestep     !Same as GCM
+  REAL :: ztime_fin     !Same as GCM
 
 ! Variable for reading start.nc
-      character (len = *), parameter :: FILE_NAME_start = "start_evol.nc" !Name of the file used for initialsing the PEM
+      character (len = *), parameter :: FILE_NAME_start = "start_0.nc" !Name of the file used for initialsing the PEM
   !   variables dynamiques
   REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) ! vents covariants
@@ -86,5 +110,8 @@
   REAL, ALLOCATABLE, DIMENSION(:,:,:):: q! champs advectes
   REAL ps(ip1jmp1)                       ! pression  au sol
-  REAL, dimension(:),allocatable :: ps_phys !(ngrid) pression  au sol
+  REAL, dimension(:),allocatable :: ps_phys !(ngrid)                       ! pression  au sol
+  REAL, dimension(:,:),allocatable :: ps_phys_timeseries !(ngrid x timelen) ! pression  au sol instantannées
+  REAL, dimension(:,:),allocatable :: ps_phys_timeseries_yr1 !(ngrid x timelen) ! pression  au sol instantannées for the first year of the gcm
+
   REAL masse(ip1jmp1,llm)                ! masse d'air
   REAL phis(ip1jmp1)                     ! geopotentiel au sol
@@ -93,8 +120,9 @@
 ! Variable for reading starfi.nc
 
-      character (len = *), parameter :: FILE_NAME = "startfi_evol.nc" !Name of the file used for initialsing the PEM
+      character (len = *), parameter :: FILE_NAME = "startfi_0.nc" !Name of the file used for initialsing the PEM
       integer :: ncid, varid,status                                !Variable for handling opening of files
       integer :: phydimid, subdimid, nlayerdimid, nqdimid          !Variable ID for Netcdf files
       integer :: lonvarid, latvarid, areavarid,sdvarid             !Variable ID for Netcdf files
+      integer :: apvarid,bpvarid				   !Variable ID for Netcdf files
 
 ! Variable for reading starfi.nc and writting restartfi.nc
@@ -102,4 +130,6 @@
       REAL, dimension(:),allocatable :: longitude                  !Longitude read in FILE_NAME and written in restartfi 
       REAL, dimension(:),allocatable  :: latitude                  !Latitude read in FILE_NAME and written in restartfi 
+      REAL, dimension(:),allocatable :: ap                         !Coefficient ap read in FILE_NAME_start and written in restart 
+      REAL, dimension(:),allocatable :: bp                         !Coefficient bp read in FILE_NAME_start and written in restart
       REAL, dimension(:),allocatable  :: cell_area                 !Cell_area read in FILE_NAME and written in restartfi 
       REAL :: Total_surface                                        !Total surface of the planet
@@ -113,16 +143,10 @@
       REAL, dimension(:),allocatable  :: tendencies_co2_ice_phys   ! physical point field : Tendency of evolution of perenial co2 ice over a year
 
-! Variable for initial situation of water ice
-
       REAL :: ini_surf                                             ! Initial surface of sublimating water ice
-      REAL :: ini_surf_h2o                                         ! Initial surface of sublimating water ice
+      REAL :: ini_surf_h2o                                             ! Initial surface of sublimating water ice
       REAL, dimension(:),allocatable  :: initial_h2o_ice           ! physical point field : Logical array indicating sublimating point
-
-! Variable for initial situation of co2 ice
 
       REAL :: ini_surf_co2                                         ! Initial surface of sublimating co2 ice
       REAL, dimension(:),allocatable  :: initial_co2_ice           ! physical point field : Logical array indicating sublimating point of co2 ice
-
-! Variable for needed to compute tendencies for water ice
 
       REAL , dimension(:,:), allocatable :: min_h2o_ice_s_1        ! LON x LAT field : minimum of water ice at each point for the first year
@@ -130,69 +154,149 @@
       REAL , dimension(:,:,:), allocatable :: h2o_ice_first_last_day     ! LON x LAT x 2 field : First and Last value of a GCM year simulation of water ice
 
-! Variable for needed to compute tendencies for co2 ice
-
       REAL , dimension(:,:), allocatable :: min_co2_ice_s_1        ! LON x LAT field : minimum of water ice at each point for the first year
       REAL , dimension(:,:), allocatable :: min_co2_ice_s_2        ! LON x LAT field : minimum of water ice at each point for the second year
       REAL , dimension(:,:,:), allocatable :: co2_ice_first_last_day     ! LON x LAT x 2 field : First and Last value of a GCM year simulation of water ice
 
-      REAL :: global_ave_press_GCM           ! physical point field : Global average pressure in the GCM output
+      REAL, dimension(:),allocatable  :: local_old_press           ! physical point field : Local pressure of initial/previous time step
+      REAL, dimension(:),allocatable  :: local_new_press           ! physical point field : Local pressure of current time step
+
+      REAL :: global_ave_press_GCM
       REAL :: global_ave_press_old           ! physical point field : Global average pressure of initial/previous time step
       REAL :: global_ave_press_new           ! physical point field : Global average pressure of current time step
 
-      REAL , dimension(:,:), allocatable :: ZPLEV_new ! ngrid x nlayer+1 : Pressure level at the end of the iteration
-      REAL , dimension(:,:), allocatable :: ZPLEV_OLD ! ngrid x nlayer+1 : Pressure level at the beginning of the iteration
-
-      INTEGER :: year_iter        !Counter for the number of PEM iteration
-      INTEGER :: year             ! Year read in the startfi files and written back in it counting the year iterations
-
+      REAL , dimension(:,:), allocatable ::  zplev_new
+      REAL , dimension(:,:), allocatable :: zplev_old
+      REAL , dimension(:,:,:), allocatable ::  zplev_new_timeseries  ! same but with the time series
+      REAL , dimension(:,:,:), allocatable :: zplev_old_timeseries! same but with the time series
+
+
+
+
+      REAL :: tot_co2_atm,tot_var_co2_atm
+
+
+      INTEGER :: year_iter  !Counter for the number of PEM iteration
       LOGICAL :: STOPPING_water   ! Logical : is the criterion (% of change in the surface of sublimating water ice) reached?
       LOGICAL :: STOPPING_1_water ! Logical : is there still water ice to sublimate?
-
-      LOGICAL :: STOPPING_co2     ! Logical : is the criterion (% of change in the surface of sublimating co2 ice) reached?
-      LOGICAL :: STOPPING_1_co2   ! Logical : is there still co2 ice to sublimate?
-
-      REAL, dimension(:),allocatable  :: q_co2_GCM ! Initial amount of co2 in the first layer
-      REAL ps_GCM(ip1jmp1)                         ! pression  au sol donné par le GCM
-
-      real ,allocatable :: vmr_co2_gcm_phys(:,:)   !(ngrid x Timelen) : co2 volume mixing ratio given by the GCM 
-      REAL, ALLOCATABLE ::  vmr_co2_gcm(:,:,:)     ! iim+1 x jjm+1 x Timelen : co2 volume mixing ratio given by the GCM
-
-      REAL, ALLOCATABLE ::  ps_GCM_1(:,:,:)        ! iim+1 x jjm+1 x Timelen : Surface pressure in the first GCM year
-      REAL, ALLOCATABLE ::  ps_GCM_2(:,:,:)        ! iim+1 x jjm+1 x Timelen : Surface pressure in the second GCM year
-
-      integer :: timelen                           ! Number of time point in the GCM diagfi output
-
-      REAL, ALLOCATABLE :: p(:,:)                  !(ngrid,llmp1) : Pressure
+      LOGICAL :: STOPPING_co2   ! Logical : is the criterion (% of change in the surface of sublimating water ice) reached?
+      LOGICAL :: STOPPING_1_co2 ! Logical : is there still water ice to sublimate?
+
+      REAL, dimension(:,:,:),allocatable  :: q_co2_GCM ! Initial amount of co2 in the first layer
+
+      real,save :: m_co2, m_noco2, A , B, mmean
+      real ,allocatable :: vmr_co2_gcm_phys(:,:) !(ngrid) ! co2 volume mixing ratio
+      real ,allocatable :: vmr_co2_pem_phys(:,:) !(ngrid) ! co2 volume mixing ratio
+      real ,allocatable :: q_h2o_GCM_phys(:,:)
+      real ,allocatable :: q_co2_GCM_phys(:,:)
+      real ,allocatable :: q_co2_PEM_phys(:,:)
+      REAL, ALLOCATABLE ::  ps_GCM(:,:,:)
+      REAL, ALLOCATABLE :: ps_GCM_yr1(:,:,:)
+      REAL, ALLOCATABLE ::  vmr_co2_gcm(:,:,:)
+      REAL, ALLOCATABLE ::  q_h2o_GCM(:,:,:)
+      REAL ,allocatable ::  q_h2o_PEM_phys(:,:)
+      real ,allocatable :: q_phys(:,:,:) 
+      integer :: timelen
+      REAL :: ave
+
+      REAL, ALLOCATABLE :: p(:,:)  !(ngrid,llmp1)
+      REAL :: extra_mass ! Extra mass of a tracer if it is greater than 1
+
+      REAL :: deficit_mass ! Extra mass of a tracer if it is lower than 0
+
+
+
 
 !!!!!!!!!!!!!!!!!!!!!!!! SLOPE
-      REAL ,allocatable :: watercap_slope(:,:)                           ! (ngrid,nslope)
-      REAL , dimension(:,:,:), allocatable :: min_co2_ice_slope_1        ! LON x LAT field : minimum of co2 ice at each point for the first year
-      REAL , dimension(:,:,:), allocatable :: min_co2_ice_slope_2        ! LON x LAT field : minimum of co2 ice at each point for the second year
+      character*2 :: str2
+      REAL ,allocatable :: watercap_slope(:,:)    !(ngrid,nslope)
+      REAL , dimension(:,:,:), allocatable :: min_co2_ice_slope_1        ! LON x LAT field : minimum of water ice at each point for the first year
+      REAL , dimension(:,:,:), allocatable :: min_co2_ice_slope_2        ! LON x LAT field : minimum of water ice at each point for the second year
       REAL , dimension(:,:,:), allocatable :: min_h2o_ice_slope_1        ! LON x LAT field : minimum of water ice at each point for the first year
       REAL , dimension(:,:,:), allocatable :: min_h2o_ice_slope_2        ! LON x LAT field : minimum of water ice at each point for the second year
 
+
+      REAL , dimension(:,:,:,:), allocatable :: co2_ice_GCM_slope        ! LON x LATX NSLOPE x Times field : co2 ice given by the GCM
+      REAL , dimension(:,:,:), allocatable :: co2_ice_GCM_phys_slope        ! LON x LATX NSLOPE x Times field : co2 ice given by the GCM
+
+
+      REAL, dimension(:,:),allocatable  :: initial_co2_ice_sublim_slope           ! physical point field : Logical array indicating sublimating point of co2 ice
+      REAL, dimension(:,:),allocatable  :: initial_h2o_ice_slope           ! physical point field : Logical array indicating sublimating point of h2o ice
       REAL, dimension(:,:),allocatable  :: initial_co2_ice_slope           ! physical point field : Logical array indicating sublimating point of co2 ice
-      REAL, dimension(:,:),allocatable  :: initial_h2o_ice_slope           ! physical point field : Logical array indicating sublimating point of co2 ice
 
       REAL , dimension(:,:,:), allocatable :: tendencies_co2_ice_slope     ! LON x LAT field : Tendency of evolution of perenial co2 ice over a year
       REAL , dimension(:,:,:), allocatable :: tendencies_h2o_ice_slope     ! LON x LAT field : Tendency of evolution of perenial co2 ice over a year
       REAL, dimension(:,:),allocatable  :: tendencies_co2_ice_phys_slope   ! physical point field : Tendency of evolution of perenial co2 ice over a year
+      REAL, dimension(:,:),allocatable  :: tendencies_co2_ice_phys_slope_ini ! physical point field x nslope: Tendency of evolution of perenial co2 ice over a year in the GCM
       REAL, dimension(:,:),allocatable  :: tendencies_h2o_ice_phys_slope   ! physical point field : Tendency of evolution of perenial co2 ice over a year
 
       REAL, PARAMETER :: co2_hmax = 10 			  ! Maximum height  for CO2 deposit on slopes (m)
-      REAL, PARAMETER :: rho_co2 = 1600                   ! CO2 ice density (kg/m^3)
-      INTEGER :: iaval                                    ! Index of the neighboord slope ()
+      REAL, PARAMETER :: rho_co2 = 1600           ! CO2 ice density (kg/m^3)
+      INTEGER :: iaval                            ! Index of the neighboord slope ()
       REAL , dimension(:,:), allocatable :: flag_co2flow(:,:)   !(ngrid,nslope)          ! To flag where there is a glacier flow
       REAL , dimension(:), allocatable :: flag_co2flow_mesh(:)  !(ngrid)          ! To flag where there is a glacier flow
 
 
-
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! SURFACE/SOIL 
+
+
+     REAL, ALLOCATABLE :: tsurf_ave(:,:,:) ! LON x LAT x SLOPE field : Averaged Surface Temperature [K]
+     REAL, ALLOCATABLE  :: tsurf_ave_phys(:,:) ! IG x LAT x SLOPE field : Averaged Surface Temperature [K]
+     REAL, ALLOCATABLE :: tsoil_ave(:,:,:,:) ! LON x LAT x SLOPE field : Averaged Soil Temperature [K]
+     REAL, ALLOCATABLE :: tsoil_ave_yr1(:,:,:,:) ! LON x LAT x SLOPE field : Averaged Soil Temperature [K]
+     REAL, ALLOCATABLE :: tsoil_ave_phys_yr1(:,:,:) !IG x SLOPE field : Averaged Soil Temperature [K]
+
+     REAL, ALLOCATABLE :: TI_GCM(:,:,:,:) ! LON x LAT x SLOPE field : Averaged Thermal Inertia  [SI]
+     REAL, ALLOCATABLE :: tsurf_GCM_timeseries(:,:,:,:) !LONX LAT x SLOPE XTULES field : NOn averaged Surf Temperature [K]
+     REAL, ALLOCATABLE :: tsurf_phys_GCM_timeseries(:,:,:) !IG x SLOPE XTULES field : NOn averaged Surf Temperature [K]
+
+     REAL, ALLOCATABLE :: tsoil_phys_PEM_timeseries(:,:,:,:) !IG x SLOPE XTULES field : NOn averaged Soil Temperature [K]
+     REAL, ALLOCATABLE :: tsoil_GCM_timeseries(:,:,:,:,:) !IG x SLOPE XTULES field : NOn averaged Soil Temperature [K]
+
+     REAL, ALLOCATABLE :: tsurf_ave_yr1(:,:,:) ! LON x LAT x SLOPE field : Averaged Surface Temperature of the first year of the gcm [K]
+     REAL, ALLOCATABLE  :: tsurf_ave_phys_yr1(:,:) ! IG x LAT x SLOPE field : Averaged Surface Temperature of first call of the gcm [K]
+
+
+
+     REAL :: tol_soil = 1.e-6
+     INTEGER :: countmax = 15
+     INTEGER :: countloop
+     REAL, ALLOCATABLE :: tsoil_phys_PEM_saved(:,:,:)
+     REAL :: error_tsoil
+
+
+     LOGICAL :: firstcall
+!    REAL, PARAMETER :: daysec=88775.              ! duree du sol (s)  ~88775 s
+     REAL, PARAMETER :: year_day = 669
+     REAL, PARAMETER :: year_step = 1
+     REAL :: timestep
+
+     REAL, ALLOCATABLE :: inertiesoil(:,:) ! Thermal inertia of the mesh for restart
+
+     REAL, ALLOCATABLE :: TI_GCM_phys(:,:,:) ! Averaged GCM Thermal Inertia  [SI]
+     REAL, ALLOCATABLE :: TI_GCM_start(:,:,:) ! Averaged GCM Thermal Inertia  [SI]
+
+     REAL,ALLOCATABLE  :: q_h2o_PEM_phys_ave(:) ! averaged water vapor content
+     REAL,ALLOCATABLE  :: interp_coef(:)
+
+     REAL,ALLOCATABLE  :: ice_depth(:,:)
+     REAL,ALLOCATABLE  :: TI_locslope(:,:)
+     REAL,ALLOCATABLE  :: Tsoil_locslope(:,:)
+     REAL,ALLOCATABLE  :: Tsoil_locslope_CN(:,:)
+     REAL,ALLOCATABLE  :: Tsurf_locslope(:)
+     REAL,ALLOCATABLE  :: Tsurf_locslope_prev(:)
+     REAL,ALLOCATABLE  :: alph_locslope(:,:)
+     REAL,ALLOCATABLE  :: beta_locslope(:,:)   
+     REAL :: kcond
+     REAL,ALLOCATABLE  :: Tsurfave_before_saved(:,:)
+     REAL, ALLOCATABLE :: delta_co2_adsorbded(:)
+     REAL :: totmass_adsorbded
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
 ! Loop variable
-     INTEGER :: i,j,ig0,l,ig,nnq,t,islope
-! Constant
-     REAL :: pi,beta,alpha
-
+     LOGICAL :: bool_sublim
+     INTEGER :: i,j,ig0,l,ig,nnq,t,islope,ig_loop,islope_loop,iloop
+     REAL :: beta = 3182.48
+     REAL :: alpha = 23.3494
+  
 ! Parallel variables
       is_sequential=.true.
@@ -205,7 +309,14 @@
       time_phys=0. !test
 
-!------------------------
-
-!=======================================================
+!      n_band_lat=18
+
+      m_co2 = 44.01E-3  ! CO2 molecular mass (kg/mol)   
+      m_noco2 = 33.37E-3  ! Non condensible mol mass (kg/mol)   
+      A =(1/m_co2 - 1/m_noco2)
+      B=1/m_noco2
+
+
+
+!------------------------
 
 ! I   Initialisation
@@ -219,4 +330,5 @@
       CALL conf_evol( 99, .TRUE. )
 
+
 !------------------------
 
@@ -262,14 +374,28 @@
 
 !----------------------------READ start.nc --------------------- 
-
-    call infotrac_init
+    
+     call infotrac_init
 
      allocate(q(ip1jmp1,llm,nqtot))
-
      CALL dynetat0(FILE_NAME_start,vcov,ucov, &
                     teta,q,masse,ps,phis, time_0)
 
-     CALL iniconst 
+     CALL iniconst !new
      CALL inigeom
+     allocate(ap(nlayer+1))
+     allocate(bp(nlayer+1))
+     status =nf90_open(FILE_NAME_start, NF90_NOWRITE, ncid)
+     status = nf90_inq_varid(ncid, "ap", apvarid)
+     status = nf90_get_var(ncid, apvarid, ap)
+     status = nf90_inq_varid(ncid, "bp", bpvarid)
+     status = nf90_get_var(ncid, bpvarid, bp)
+     status =nf90_close(ncid)
+     
+        
+   
+    daysec=88775.
+    dtphys=0
+
+ 
 
     CALL iniphysiq(iim,jjm,llm, &
@@ -278,8 +404,9 @@
           rlatu,rlatv,rlonu,rlonv,aire,cu,cv,rad,g,r,cpp, &
           iflag_phys)
-
-     year=day_ini
-
-
+   DO nnq=1,nqtot
+    if(noms(nnq).eq."h2o_ice") igcm_h2o_ice = nnq
+   ENDDO 
+
+ 
 !----------------------------reading ---------------------
 
@@ -287,5 +414,10 @@
 ! First we read the initial state (starfi.nc)
 
+
        allocate(watercap_slope(ngrid,nslope))
+       allocate(TI_GCM_start(ngrid,nsoilmx,nslope))
+       allocate(q_h2o_PEM_phys_ave(ngrid))
+      allocate(inertiesoil(ngrid,nsoilmx))
+
 
          CALL phyetat0 (FILE_NAME,0,0, &
@@ -294,10 +426,27 @@
               tsurf,tsoil,albedo,emis,   &
               q2,qsurf,co2ice,tauscaling,totcloudfrac,wstar,     &
-              watercap,nslope,tsurf_slope,                       &
+              watercap,inertiesoil,nslope,tsurf_slope,           &
               tsoil_slope,co2ice_slope,def_slope,def_slope_mean, &
-              subslope_dist,albedo_slope,emiss_slope,            &
+              subslope_dist,albedo_slope,emiss_slope, TI_GCM_start,     &
               qsurf_slope,watercap_slope)
 
-! Slope : Definition of the flat slope
+
+
+     deallocate(TI_GCM_start) !not used then
+
+     DO i=1,ngrid
+         DO nnq=1,nqtot
+           DO islope=1,nslope
+             if(qsurf_slope(i,nnq,islope).LT.0) then
+                qsurf_slope(i,nnq,islope)=0.
+             endif
+           enddo
+         enddo
+       enddo
+
+!     Define some slope statistics
+
+
+      
 
        iflat=1
@@ -306,66 +455,242 @@
            abs(def_slope_mean(iflat)))THEN
            iflat = islope
-         ENDIF
+         ENDIF     
+
        ENDDO
        PRINT*,'Flat slope for islope = ',iflat
        PRINT*,'corresponding criterium = ',def_slope_mean(iflat)
 
-     allocate(flag_co2flow(ngrid,nslope))
-     allocate(flag_co2flow_mesh(ngrid))
-
        flag_co2flow(:,:) = 0.     
        flag_co2flow_mesh(:) = 0.
 
-
-! Then we read the evolution of water and co2 ice over the first year of the GCM run, saving only the minimum value
-
+!------------------------
+
+! I   Initialisation
+!    I_a READ run.def , run_pem.def
+!    I_b READ starfi_0.nc
+!    I_c READ GCM data and convert to the physical grid 
+
+!------------------------
+
+! First we read the evolution of water and co2 ice (and the mass mixing ratio) over the first year of the GCM run, saving only the minimum value
+
+
+     call nb_time_step_GCM("concat_year_one.nc",timelen)
      allocate(min_h2o_ice_s_1(iim+1,jjm+1))
      allocate(min_co2_ice_s_1(iim+1,jjm+1))
-
-     allocate(ps_GCM_1(iim+1,jjm+1,2676))
-
+     allocate(vmr_co2_gcm(iim+1,jjm+1,timelen))
+     allocate(q_h2o_GCM(iim+1,jjm+1,timelen))
+     allocate(q_co2_GCM(iim+1,jjm+1,timelen))
+     allocate(ps_GCM(iim+1,jjm+1,timelen))
+     allocate(ps_GCM_yr1(iim+1,jjm+1,timelen))
      allocate(min_co2_ice_slope_1(iim+1,jjm+1,nslope))
      allocate(min_h2o_ice_slope_1(iim+1,jjm+1,nslope))
-
-     allocate(vmr_co2_gcm(iim+1,jjm+1,2676))
-
-     call pemetat0 ("concat_year_one.nc", min_h2o_ice_s_1,min_co2_ice_s_1,iim,jjm,nlayer,vmr_co2_gcm,ps_GCM_1,timelen,min_co2_ice_slope_1,min_h2o_ice_slope_1,nslope)
-
-! Then we read the evolution of water and co2 ice over the second year of the GCM run, saving only the minimum value
+     allocate(tsurf_ave(iim+1,jjm+1,nslope))
+     allocate(tsurf_ave_yr1(iim+1,jjm+1,nslope))
+     allocate(tsoil_ave(iim+1,jjm+1,nsoilmx,nslope))
+     allocate(tsoil_ave_yr1(iim+1,jjm+1,nsoilmx,nslope))
+     allocate(tsoil_ave_phys_yr1(ngrid,nsoilmx_PEM,nslope))
+     allocate(tsurf_ave_phys(ngrid,nslope))
+     allocate(tsurf_ave_phys_yr1(ngrid,nslope))
+     allocate(TI_GCM(iim+1,jjm+1,nsoilmx,nslope))
+     allocate(tsoil_GCM_timeseries(iim+1,jjm+1,nsoilmx,nslope,timelen))
+     allocate(tsoil_phys_PEM_timeseries(ngrid,nsoilmx_PEM,nslope,timelen))
+
+     allocate(tsurf_GCM_timeseries(iim+1,jjm+1,nslope,timelen))
+     allocate(tsurf_phys_GCM_timeseries(ngrid,nslope,timelen))
+     allocate(co2_ice_GCM_phys_slope(ngrid,nslope,timelen))
+     allocate(co2_ice_GCM_slope(iim+1,jjm+1,nslope,timelen))
+     allocate(Tsurfave_before_saved(ngrid,nslope))
+     allocate(tsoil_phys_PEM_saved(ngrid,nsoilmx_PEM,nslope))
+     allocate(delta_co2_adsorbded(ngrid))
+     allocate(q_phys(ngrid,llm,nqtot))
+
+
+
+     call read_data_GCM("concat_year_one.nc", min_h2o_ice_s_1,min_co2_ice_s_1,iim,jjm,nlayer,vmr_co2_gcm,ps_GCM_yr1,timelen,min_co2_ice_slope_1,min_h2o_ice_slope_1,&   
+                       nslope,tsurf_ave_yr1,tsoil_ave_yr1, tsurf_GCM_timeseries,tsoil_GCM_timeseries,TI_GCM,q_co2_GCM,q_h2o_GCM,co2_ice_GCM_slope)
+
+
+! Then we read the evolution of water and co2 ice (and the mass mixing ratio) over the second year of the GCM run, saving only the minimum value
 
      allocate(min_h2o_ice_s_2(iim+1,jjm+1))
      allocate(min_co2_ice_s_2(iim+1,jjm+1))
-
      allocate(min_co2_ice_slope_2(iim+1,jjm+1,nslope))
      allocate(min_h2o_ice_slope_2(iim+1,jjm+1,nslope))
 
-     allocate(ps_GCM_2(iim+1,jjm+1,2676))
-
-     call pemetat0 ("concat_year_two.nc", min_h2o_ice_s_2,min_co2_ice_s_2,iim,jjm,nlayer,vmr_co2_gcm,ps_GCM_2,timelen,min_co2_ice_slope_2,min_h2o_ice_slope_2,nslope)
-
-! We read the evolutaion of water ice over the first year of the GCM run, saving the first and last state
+     call read_data_GCM("concat_year_two.nc", min_h2o_ice_s_2,min_co2_ice_s_2,iim,jjm,nlayer,vmr_co2_gcm,ps_GCM,timelen,min_co2_ice_slope_2,min_h2o_ice_slope_2, &
+                  nslope,tsurf_ave,tsoil_ave, tsurf_GCM_timeseries,tsoil_GCM_timeseries,TI_GCM,q_co2_GCM,q_h2o_GCM,co2_ice_GCM_slope)
+
+
+
+
+! The variables in the dynamic grid are transfered to the physical grid
+
 
      allocate(vmr_co2_gcm_phys(ngrid,timelen))
-
-  vmr_co2_gcm_phys(1,:)=vmr_co2_gcm(1,1,:)
-
-  ig0 = 2
-  DO j=2,jjm
-    DO i = 1, iim
-       vmr_co2_gcm_phys(ig0,:)  =vmr_co2_gcm(i,j,:)
-       ig0= ig0 + 1
-    ENDDO
-  ENDDO
-
-  vmr_co2_gcm_phys(ig0,:) = vmr_co2_gcm(1,jjm+1,:)
-
-!=======================================================
-
-! II  Run
-!    II_a Compute tendencies
-
-!------------------------
-
-!---------------------------- RUN ---------------------
+     allocate(vmr_co2_pem_phys(ngrid,timelen))
+     allocate(q_h2o_GCM_phys(ngrid,timelen))
+     allocate(q_h2o_PEM_phys(ngrid,timelen))
+     allocate(q_co2_GCM_phys(ngrid,timelen))
+     allocate(q_co2_PEM_phys(ngrid,timelen))
+
+
+     CALL gr_dyn_fi(timelen,iip1,jjp1,ngridmx,vmr_co2_gcm,vmr_co2_gcm_phys)
+     CALL gr_dyn_fi(timelen,iip1,jjp1,ngridmx,q_h2o_GCM,q_h2o_GCM_phys)
+     CALL gr_dyn_fi(timelen,iip1,jjp1,ngridmx,q_co2_GCM,q_co2_GCM_phys)
+
+     do nnq=1,nqtot
+
+        call gr_dyn_fi(llm,iip1,jjp1,ngridmx,q(:,:,nnq),q_phys(:,:,nnq))
+     enddo
+
+
+     deallocate(vmr_co2_gcm)
+     deallocate(q_h2o_GCM)
+     deallocate(q_co2_GCM)
+
+
+    q_co2_PEM_phys(:,:)=  q_co2_GCM_phys(:,:)
+    q_h2o_PEM_phys(:,:)=  q_h2o_GCM_phys(:,:)
+
+
+     allocate(ps_phys(ngrid))
+     allocate(ps_phys_timeseries(ngrid,timelen))
+     allocate(ps_phys_timeseries_yr1(ngrid,timelen))
+
+
+
+
+
+     call gr_dyn_fi(1,iip1,jjp1,ngridmx,ps,ps_phys)
+
+
+! for the time series:
+
+
+
+    call gr_dyn_fi(timelen,iip1,jjp1,ngridmx,ps_GCM,ps_phys_timeseries)
+    call gr_dyn_fi(timelen,iip1,jjp1,ngridmx,ps_GCM_yr1,ps_phys_timeseries_yr1)
+    deallocate(ps_GCM)
+    deallocate(ps_GCM_yr1)
+
+
+!!!!!!!!!!!!!!!!!!!!! Initialisation for soil_PEM
+
+      call end_comsoil_h_PEM
+      call ini_comsoil_h_PEM(ngrid,nslope)
+      timestep=year_day*daysec/year_step
+
+
+      allocate(ice_depth(ngrid,nslope))
+      allocate(TI_GCM_phys(ngrid,nsoilmx,nslope))
+
+      DO islope = 1,nslope
+          CALL gr_dyn_fi(nsoilmx,iip1,jjp1,ngridmx,TI_GCM(:,:,:,islope),TI_GCM_phys(:,:,islope))
+      ENDDO
+
+
+      call soil_settings_PEM(ngrid,nslope,nsoilmx_PEM,nsoilmx,TI_GCM_phys,TI_PEM)
+
+      deallocate(TI_GCM)
+
+
+      DO islope = 1,nslope
+
+        DO l=1,nsoilmx
+           CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,tsoil_ave_yr1(:,:,l,islope),tsoil_ave_phys_yr1(:,l,islope))
+        ENDDO
+        DO l=nsoilmx+1,nsoilmx_PEM
+           CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,tsoil_ave_yr1(:,:,nsoilmx,islope),tsoil_ave_phys_yr1(:,l,islope))
+        ENDDO
+      ENDDO
+
+
+
+       deallocate(tsoil_ave_yr1)
+
+
+
+
+
+
+
+
+
+
+      DO islope = 1,nslope
+
+        DO l=1,nsoilmx
+           CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,tsoil_ave(:,:,l,islope),tsoil_PEM(:,l,islope))
+        ENDDO
+        DO l=nsoilmx+1,nsoilmx_PEM
+           CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,tsoil_ave(:,:,nsoilmx,islope),tsoil_PEM(:,l,islope))
+        ENDDO
+      ENDDO
+     
+
+
+       deallocate(tsoil_ave)
+
+
+      DO islope = 1,nslope
+       
+        DO l=1,nsoilmx
+          DO t=1,timelen
+           CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,tsoil_GCM_timeseries(:,:,l,islope,t),tsoil_phys_PEM_timeseries(:,l,islope,t))
+          ENDDO
+        ENDDO
+      ENDDO
+
+      deallocate(tsoil_GCM_timeseries)
+     
+ 
+
+
+       CALL gr_dyn_fi(nslope,iip1,jjp1,ngridmx,tsurf_ave,tsurf_ave_phys)
+       
+       CALL gr_dyn_fi(nslope,iip1,jjp1,ngridmx,tsurf_ave_yr1,tsurf_ave_phys_yr1)
+
+       deallocate(tsurf_ave)
+       deallocate(tsurf_ave_yr1)
+
+   
+
+
+      DO islope = 1,nslope
+
+        DO t=1,timelen
+          CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,tsurf_GCM_timeseries(:,:,islope,t),tsurf_phys_GCM_timeseries(:,islope,t))
+        enddo
+      enddo
+      deallocate(tsurf_GCM_timeseries)
+
+
+  DO islope = 1,nslope
+
+        DO t=1,timelen
+          CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,co2_ice_GCM_slope(:,:,islope,t),co2_ice_GCM_phys_slope(:,islope,t))
+        enddo
+      enddo
+
+
+
+      deallocate(co2_ice_GCM_slope)
+
+
+
+!------------------------
+
+! I   Initialisation
+!    I_a READ run.def , run_pem.def
+!    I_b READ starfi_0.nc
+!    I_c READ GCM data and convert to the physical grid 
+!    I_d Compute tendencies & Save initial situation
+
+!------------------------
+
+
+
+
 
 !----- Compute tendencies
@@ -380,4 +705,6 @@
      allocate(tendencies_co2_ice_slope(iim+1,jjm+1,nslope))
      allocate(tendencies_co2_ice_phys_slope(ngrid,nslope))
+     allocate(tendencies_co2_ice_phys_slope_ini(ngrid,nslope))
+
 
      allocate(tendencies_h2o_ice_slope(iim+1,jjm+1,nslope))
